from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.http import HttpResponse, HttpResponseNotFound
from django.views.generic import View
from django.contrib import messages
from .forms import MediaForm, BlogForm
from .models import Photo


def home(request):
    dataview = dict()
    dataview['photos'] = Photo.objects.all()
    return render(request, 'blog/home.html', dataview)


@login_required
def restricted(request):
    return render(request, 'blog/restricted.html')


def not_found(request, exception):
    print("enter not found")
    return render(request,
                    '404.html',
                    context={"exception": exception},
                    status=404)
    return render(request,
                  '404.html',
                  context={"exception": exception},
                  status=404)

class PhotoUploadView(LoginRequiredMixin, View):
    dataview = dict()
    template_name = 'blog/media_upload.html'
    form_class = MediaForm

    def get(self, request):
        self.dataview['form'] = self.form_class()
        return render(request, self.template_name, self.dataview)

    def post(self, request):
        self.dataview['form'] = form = self.form_class(request.POST,
                                                       request.FILES)
        if form.is_valid():
            photo = form.save(commit=False)
            photo.uploader = request.user
            photo.save()
            messages.add_message(request,
                                 messages.INFO,
                                 'photo ajoutée avec succès')
            return redirect('home')
        return render(request, self.template_name, self.dataview)


class BlogPostCreateView(LoginRequiredMixin, View):
    dataview = dict()
    template_name = 'blog/create_blog_post.html'
    blog_form_class = BlogForm
    media_form_class = MediaForm

    def get(self, request):
        self.dataview['blog_form'] = self.blog_form_class()
        self.dataview['media_form'] = self.media_form_class()
        return render(request, self.template_name, self.dataview)

    def post(self, request):
        self.dataview['blog_form'] = blog_form = self.form_class(request.POST)
        self.dataview['media_form'] = media_form = self.form_class(request.POST,
                                                                   request.FILES)
        if all([blog_form.is_valid(), media_form.is_valid()]):
            media = media_form.save(commit=False)
            media.uploader = request.user
            media.save()
            blog_post = blog_form.save(commit=False)
            blog_post.author = request.user
            blog_post.photo = media
            blog_post.save()
            messages.add_message(request,
                                 messages.INFO,
                                 'Blog Post ajouté avec succès')
            return redirect('home')
        return render(request, self.template_name, self.dataview)

@login_required()
def blog_post(request):
    dataview = dict()
    dataview
